n_classes_dataset = {
    "cifar10": 10,
    "svhn": 10,
    "cifar100": 100
}

models_path = "./Models/"
save_features_path = "./Features/"

layers = {
    "resnet": {'relu': 'layer1',
               'layer1.0.relu': 'layer2',
               'layer1.0.relu_1': 'layer3',
               'layer1.1.relu': 'layer4',
               'layer1.1.relu_1': 'layer5',
               'layer1.2.relu': 'layer6',
               'layer1.2.relu_1': 'layer7',
               'layer2.0.relu': 'layer8',
               'layer2.0.relu_1': 'layer9',
               'layer2.1.relu': 'layer10',
               'layer2.1.relu_1': 'layer11',
               'layer2.2.relu': 'layer12',
               'layer2.2.relu_1': 'layer13',
               'layer2.3.relu': 'layer14',
               'layer2.3.relu_1': 'layer15',
               'layer3.0.relu': 'layer16',
               'layer3.0.relu_1': 'layer17',
               'layer3.1.relu': 'layer18',
               'layer3.1.relu_1': 'layer19',
               'layer3.2.relu': 'layer20',
               'layer3.2.relu_1': 'layer21',
               'layer3.3.relu': 'layer22',
               'layer3.3.relu_1': 'layer23',
               'layer3.4.relu': 'layer24',
               'layer3.4.relu_1': 'layer25',
               'layer3.5.relu': 'layer26',
               'layer3.5.relu_1': 'layer27',
               'layer4.0.relu': 'layer28',
               'layer4.0.relu_1': 'layer29',
               'layer4.1.relu': 'layer30',
               'layer4.1.relu_1': 'layer31',
               'layer4.2.relu': 'layer32',
               'layer4.2.relu_1': 'layer33'},
    "densenet": {'block1.layer.0.relu': 'layer1',
                 'block1.layer.0.relu_1': 'layer2',
                 'block1.layer.1.relu': 'layer3',
                 'block1.layer.1.relu_1': 'layer4',
                 'block1.layer.2.relu': 'layer5',
                 'block1.layer.2.relu_1': 'layer6',
                 'block1.layer.3.relu': 'layer7',
                 'block1.layer.3.relu_1': 'layer8',
                 'block1.layer.4.relu': 'layer9',
                 'block1.layer.4.relu_1': 'layer10',
                 'block1.layer.5.relu': 'layer11',
                 'block1.layer.5.relu_1': 'layer12',
                 'block1.layer.6.relu': 'layer13',
                 'block1.layer.6.relu_1': 'layer14',
                 'block1.layer.7.relu': 'layer15',
                 'block1.layer.7.relu_1': 'layer16',
                 'block1.layer.8.relu': 'layer17',
                 'block1.layer.8.relu_1': 'layer18',
                 'block1.layer.9.relu': 'layer19',
                 'block1.layer.9.relu_1': 'layer20',
                 'block1.layer.10.relu': 'layer21',
                 'block1.layer.10.relu_1': 'layer22',
                 'block1.layer.11.relu': 'layer23',
                 'block1.layer.11.relu_1': 'layer24',
                 'block1.layer.12.relu': 'layer25',
                 'block1.layer.12.relu_1': 'layer26',
                 'block1.layer.13.relu': 'layer27',
                 'block1.layer.13.relu_1': 'layer28',
                 'block1.layer.14.relu': 'layer29',
                 'block1.layer.14.relu_1': 'layer30',
                 'block1.layer.15.relu': 'layer31',
                 'block1.layer.15.relu_1': 'layer32',
                 'trans1.relu': 'layer33',
                 'block2.layer.0.relu': 'layer34',
                 'block2.layer.0.relu_1': 'layer35',
                 'block2.layer.1.relu': 'layer36',
                 'block2.layer.1.relu_1': 'layer37',
                 'block2.layer.2.relu': 'layer38',
                 'block2.layer.2.relu_1': 'layer39',
                 'block2.layer.3.relu': 'layer40',
                 'block2.layer.3.relu_1': 'layer41',
                 'block2.layer.4.relu': 'layer42',
                 'block2.layer.4.relu_1': 'layer43',
                 'block2.layer.5.relu': 'layer44',
                 'block2.layer.5.relu_1': 'layer45',
                 'block2.layer.6.relu': 'layer46',
                 'block2.layer.6.relu_1': 'layer47',
                 'block2.layer.7.relu': 'layer48',
                 'block2.layer.7.relu_1': 'layer49',
                 'block2.layer.8.relu': 'layer50',
                 'block2.layer.8.relu_1': 'layer51',
                 'block2.layer.9.relu': 'layer52',
                 'block2.layer.9.relu_1': 'layer53',
                 'block2.layer.10.relu': 'layer54',
                 'block2.layer.10.relu_1': 'layer55',
                 'block2.layer.11.relu': 'layer56',
                 'block2.layer.11.relu_1': 'layer57',
                 'block2.layer.12.relu': 'layer58',
                 'block2.layer.12.relu_1': 'layer59',
                 'block2.layer.13.relu': 'layer60',
                 'block2.layer.13.relu_1': 'layer61',
                 'block2.layer.14.relu': 'layer62',
                 'block2.layer.14.relu_1': 'layer63',
                 'block2.layer.15.relu': 'layer64',
                 'block2.layer.15.relu_1': 'layer65',
                 'trans2.relu': 'layer66',
                 'block3.layer.0.relu': 'layer67',
                 'block3.layer.0.relu_1': 'layer68',
                 'block3.layer.1.relu': 'layer69',
                 'block3.layer.1.relu_1': 'layer70',
                 'block3.layer.2.relu': 'layer71',
                 'block3.layer.2.relu_1': 'layer72',
                 'block3.layer.3.relu': 'layer73',
                 'block3.layer.3.relu_1': 'layer74',
                 'block3.layer.4.relu': 'layer75',
                 'block3.layer.4.relu_1': 'layer76',
                 'block3.layer.5.relu': 'layer77',
                 'block3.layer.5.relu_1': 'layer78',
                 'block3.layer.6.relu': 'layer79',
                 'block3.layer.6.relu_1': 'layer80',
                 'block3.layer.7.relu': 'layer81',
                 'block3.layer.7.relu_1': 'layer82',
                 'block3.layer.8.relu': 'layer83',
                 'block3.layer.8.relu_1': 'layer84',
                 'block3.layer.9.relu': 'layer85',
                 'block3.layer.9.relu_1': 'layer86',
                 'block3.layer.10.relu': 'layer87',
                 'block3.layer.10.relu_1': 'layer88',
                 'block3.layer.11.relu': 'layer89',
                 'block3.layer.11.relu_1': 'layer90',
                 'block3.layer.12.relu': 'layer91',
                 'block3.layer.12.relu_1': 'layer92',
                 'block3.layer.13.relu': 'layer93',
                 'block3.layer.13.relu_1': 'layer94',
                 'block3.layer.14.relu': 'layer95',
                 'block3.layer.14.relu_1': 'layer96',
                 'block3.layer.15.relu': 'layer97',
                 'block3.layer.15.relu_1': 'layer98',
                 'relu': 'layer99'}
}

models_gdrive_ids = {
    "resnet_cifar10": "18_LAfCF4qa7jCDmITcqYD8A9yUgedqlh",
    "resnet_cifar100": "1vXI4BLXoeo_jEC2IE3geOwdrowA6-Xwa",
    "resnet_svhn": "1S5BIC2DCr_1phv8SFn0APtIs6dD8QxQ2",
    "densenet_cifar10": "1I2NAlgeNdMqVKgYeTkXIOol5Wge2Intg",
    "densenet_cifar100": "1HKvyBHPYFIEBId_eBW5K0x97IrzEaehF",
    "densenet_svhn": "1XldtdXjDVpgjxGZxueNrZJWxls34OTWn"
}